<template>
  <div>
    <q-dialog v-model="openModal">
      <q-card>
        <q-card-section>
          <div class="text-h6">¿Estás seguro de eliminar {{ label }}?</div>
        </q-card-section>

        <q-card-section class="q-pt-none">
          Escribe ELIMINAR para confirmar
        </q-card-section>

        <q-card-section class="q-pt-none q-pb-none">
          <Input
            variable="delete"
            type="text"
            :errors="errors"
            :outlined="true"
            :dense="true"
            :value.sync="value"
          />
        </q-card-section>

        <q-card-actions align="right" class="q-pt-none">
          <q-btn
            unelevated
            class="my-button-style q-mt-md"
            dense
            color="red"
            :loading="requestServer"
            :disabled="buttonAction"
            @click="clickConfirm"
          >
            Eliminar
          </q-btn>
          <!--@click="eliminarConfirmar"-->
          <q-btn
            unelevated
            class="my-button-style q-mt-md"
            dense
            color="white"
            text-color="black"
            @click="restoreEl"
          >
            Cancelar
          </q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>
  </div>
</template>
<script>
import Input from "../form/Input";

export default {
  components: {
    Input,
  },
  props: {
    openModalParent: Boolean,
    label: String,
    requestServer: Boolean,
  },
  data() {
    return {
      errors: {},
      value: "",
      openModal: false,
      buttonAction: true,
    };
  },
  methods: {
    restoreEl() {
      this.openModal = false;
      this.buttonAction = true;
    },
    clickConfirm() {
      this.$emit("confirm", this.buttonAction);
    },
  },
  watch: {
    openModalParent: {
      immediate: true,
      handler: function (newValue) {
        this.openModal = newValue;
      },
    },
    openModal: function (newValue, oldValue) {
      if (!newValue) {
        this.buttonAction = true;
      }
      this.$emit("update:openModal", newValue);
    },
    value: function (val) {
      if (val === val.toUpperCase() && val === "ELIMINAR") {
        this.buttonAction = false;
      } else {
        this.buttonAction = true;
      }
    },
  },
};
</script>